
/* Custom Encoders */
void Enc_6By7MTRCode(int *UserBits, int *EncodedBits, int *SecLen);
void Enc_8By9TMTRCode(int *UserBits, int *EncodedBits, int *SecLen);
void Enc_4By5RLLCode(int *UserBits, int *EncodedBits, int *SecLen);

/* Custom Decoders */
void Dec_6By7MTRCode(int *NRZViterbiOutput, int *NRZDecodedOutput, int PrePaddingLength, int SectorLength);
int Dec_8By9TMTRCode(int *NRZPaddedViterbiOutput, int *NRZDecodedOutput, int PrePaddingLength, int SectorLength);
int Dec_4By5RLLCode(int *NRZViterbiOutput, int *NRZDecodedOutput, int PrePaddingLength, int SectorLength);


/* Custom Viterbi Detectors */
void Viterbi_6By7MTRCode(int Delay, double *EqualizedChannelOutput, int PrePaddingLength, int SectorLength, int *DetectedOutput, double *PRImpRes, int PRImpResLength);
void Viterbi_8By9TMTRCode(int Delay, double *EqualizedChannelOutput, int PrePaddingLength, int SectorLength, int *DetectedOutput, double *PRImpRes, int PRImpResLength);
void ClassicalViterbi(int Delay, double *EqualizedChannelOutput, int SectorLength, int *DetectedOutput, double *PRImpRes, int PRImpResLength);
void ClassicalSOVA(int Delay, double *EqualizedChannelOutput, int SectorLength, int *DetectedHardOutput, double *DetectedSoftOutput, double *PRImpRes, int PRImpResLength, double NoiseSigma);
void SOVA_8By9MTRCode(int Delay, double *EqualizedChannelOutput, int PrePaddingLength, int SectorLength, int *DetectedHardOutput, double *DetectedSoftOutput, double *PRImpRes, int PRImpResLength, double NoiseSigma);
void ClassicalViterbiForTempModWithPerm(int Delay, double *EqualizedChannelOutput, int SectorLength, int *DetectedOutput, double *PRImpRes, 
										int PRImpResLength, double *MSE, int NumBitsRepPermPeriod, int SubSectorLength, int NumInterleavedBits, int PrePaddingLength);

/* Misc */
int Permute(int *InputWord, int *PermutedWord, int SectorLength, int *P, int PLength, int Period);